function init()
	motor = FindJoint("motor")	
	min, max = GetJointLimits(motor)
	speed = 1
    target = min
	trigger = FindTrigger("trigger")
	raisebutton = FindShape("raisebutton")
	lowerbutton = FindShape("lowerbutton")
	lockbutton = FindShape("lockbutton")
	boomsys = FindShape("system")
	locked = true
	buttonl = FindLight('buttonl')
	
	SetTag(raisebutton, "interact", "Raise")
	SetTag(lowerbutton, "interact", "Lower")

	
	buttonClick = LoadSound("clickup.ogg")
	motorSound = LoadLoop("vehicle/hydraulic-loop.ogg")
	oldMotorPos = GetJointMovement(motor)
	body = FindBody("body")
	SetLightEnabled(buttonl,false)
	SetTag(lockbutton, "interact", "Enable Auto-Gate")
end


function tick(dt)
	triggerpos = GetShapeWorldTransform(boomsys)
	if locked == false then 
	SetTriggerTransform(trigger, triggerpos)
	end
	local current = GetJointMovement(motor)
	if GetPlayerInteractShape() == raisebutton then
		if InputPressed("interact") then
			target = max
			speed = 0.5
			PlaySound(buttonClick,triggerpos.pos)
		end
	end
	if GetPlayerInteractShape() == lowerbutton then
		if InputPressed("interact") then
			target = min
			speed = 0.5
			PlaySound(buttonClick,triggerpos.pos)
		end
	end
	if GetPlayerInteractShape() == lockbutton then
		if InputPressed("interact") then
			if locked == false then 
				locked = true
				SetTag(lockbutton, "interact", "Enable Auto-Gate")
				SetLightEnabled(buttonl,false)
			elseif locked == true then
				locked = false
				SetTag(lockbutton, "interact", "Disable Auto-Gate")
				SetLightEnabled(buttonl,true)
			end
			speed = 0.5
			PlaySound(buttonClick,triggerpos.pos)
		end
	end

	 vehicle = GetPlayerVehicle()
	 if locked == false then
if vehicle ~= 0 then
	if IsVehicleInTrigger(trigger, vehicle) then
		target = max
		speed = 0.5
	else 
		target = min
		speed = 0.5
	end
	
else 
	target = min
		speed = 0.5
end
end
	

	--if GetJointMovement(motor) - oldMotorPos > 0.01 then
	--	PlayLoop(motorSound,GetBodyTransform(body).pos)
	--end

    if tonumber(string.format("%.0f", GetJointMovement(motor))) ~= tonumber(string.format("%.3f", target)) then
		PlayLoop(motorSound,triggerpos.pos)
	end

	oldMotorPos = GetJointMovement(motor)
	SetJointMotorTarget(motor, target, speed)	
end

